freeze;

// This might not have been tested in all situations

PREC:=Precision; 

intrinsic LSeries(f::ModFrmHilElt : Precision:=0) -> LSer
{The L-series of the Hilbert modular newform f.}

 Mf:=Parent(f);
 require assigned Mf`HeckeIrreducible and Mf`HeckeIrreducible:
  "The argument must be a Hilbert modular newform (obtained using 'Eigenform')";
 // TO DO: won't work for indefinite? because bad Heckes not availabe

 K:=BaseRing(Mf); 
 N:=Level(Mf);
 bool,w:=IsParallelWeight(Mf);
 require bool: "Only implemented for forms of parallel weight";

 E:=HeckeEigenvalueField(Mf); 
 A:=AbsoluteField(E);
 prec:=(Precision eq 0) select PREC(RealField()) else Precision;
 R1<T>:=PowerSeriesRing(RealField(prec),1+2*Degree(K));
 R2<U>:=PolynomialRing(RealField(prec)); // hack: are T and U compatible?
 ip:=InfinitePlaces(A)[1];

 function cfK(p,d : Precision:=prec) // need prec compatible
  fp:=Degree(p); P:=Norm(p);
  if fp gt d then return 1+O(T^(d+1)); end if; // need to think
  if Degree(A) eq 1 then ap:=HeckeEigenvalue(f,p);
  else ap:=Evaluate(A!HeckeEigenvalue(f,p),ip : Precision:=prec); end if;
  eps:=Valuation(N,p) gt 0 select 0 else 1; //need character generally
  return 1-ap*(U^fp)+eps*P^(w-1)*U^(2*fp); 
 end function;

 function cf(p,d : Precision:=prec) // need prec compatible
  F:=Factorization(p*Integers(K)); B:=[cfK(f[1],d) : f in F];
  if &or[Type(Parent(b)) eq Type(R2) and Parent(b) eq R2 : b in B]
   then B:=[R2!b : b in B]; end if; // think about this coercion
  return &*B; 
 end function;

 name:=<"L-series of ",f>; gamma:=&cat[[0,1] : i in [1..Degree(K)]];
 L:=LSeries(w,gamma,Norm(N)*Discriminant(Integers(K))^2,cf : Name:=name);
 L`cffuncK:=cfK; L`degreeK:=<2,K>; L`condK:=N;
 L`hodgeK:=&cat[[<[0,1,2],ip>,<[1,0,2],ip>] : ip in InfinitePlaces(K)];

 return L; 
end intrinsic;
