freeze;

import "lifns.m":LowIndexSubgroupsH;
intrinsic
LowIndexSubgroups(G::GrpPerm, maxind:: RngIntElt :
                  Presentation:=false, Print:=0, Algorithm := "Recursive",
		  Limit := Infinity ) -> SeqEnum
{ Find subgroups of index up to maxind in permutation group G}

  if Algorithm eq "Recursive" then
      s := LowIndexSubgroupsH(G,maxind :
                   Presentation:=Presentation, Print:=Print);
    elif Algorithm eq "Subgroups" then
	s := Subgroups(G : IndexLimit := maxind, Presentation := Presentation, Print := Print);
    else 
	return LowIndexSubgroupsSn(G,<1,maxind>:Limit:=Limit,Print:=Print);
    end if;
    if Presentation then
	return [ x`subgroup : x in s ], [x`presentation:x in s];
    else
	return [ x`subgroup : x in s ];
    end if;
end intrinsic;

intrinsic
LowIndexSubgroups(G::GrpPerm, T:: Tup :
                  Presentation:=false, Print:=0, Algorithm := "Recursive",
		  Limit := Infinity ) -> SeqEnum
{ Find subgroups of index up to maxind in permutation group G}

  if #T eq 1 then a:= 1; b := T[1]; 
  elif #T eq 2 then
      a := T[1]; b := T[2];
  else
    error "Second argument must be a pair of integers";
  end if;
  require Type(a) eq RngIntElt and Type(b) eq RngIntElt: 
    "Second argument must be a pair of integers";
  
  if Algorithm eq "Recursive" then
      s := LowIndexSubgroupsH(G,b :
                   Presentation:=Presentation, Print:=Print);
    elif Algorithm eq "Subgroups" then
	s := Subgroups(G : IndexLimit := b, Print := Print, Presentation:=Presentation);
    else 
	return LowIndexSubgroupsSn(G,T:Limit:=Limit,Print:=Print);
    end if;
    if Presentation then
      return [ x`subgroup : x in s | Index(G, x`subgroup) ge a],
	  [ x`presentation : x in s | Index(G, x`subgroup) ge a];
    else
	return [ x`subgroup : x in s | Index(G, x`subgroup) ge a];
    end if;
end intrinsic;
