/* 
  Method selection.
*/
  
import "charp.m":ClearFirstRowCharP, 
                 WriteTransvectionAsSLPCharP, 
                 WriteRootElementAsSLPCharP;

import "sl.m":ClearFirstRowSLBB, 
              WriteTransvectionAsSLPBBSL, 
              ClearFirstColumnSLBB, 
              WriteRootElementAsSLPBBSL;

import "spsu.m":ClearFirstRowSpSUBB, 
                WriteTransvectionAsSLPBBSpSU, 
                WriteRootElementAsSLPBBSpSU;

import "su34.m":ClearFirstRowSUBBDim3, ClearFirstRowSUBBDim4;

import "bbclassical.m":BBType, BBDimension;

ClearFirstRow := function( G, g : 
                         FirstCall := false, 
                         Method := "BB",
                         Transpose := false )

    type := BBType( G );
    dim := BBDimension( G );
    
    if Method eq "CharP" then
        return ClearFirstRowCharP( G, g : FirstCall := FirstCall, 
                       Transpose := Transpose );
    elif Method eq "BB" and type eq "SL" and not Transpose then
        return ClearFirstRowSLBB( G, g : FirstCall := FirstCall );
    elif Method eq "BB" and type eq "SL" and Transpose then
        return ClearFirstColumnSLBB( G, g );
    elif Method eq "BB" and type eq "SU" and dim eq 4 then
        return ClearFirstRowSUBBDim4( G, g : FirstCall := FirstCall );
    elif Method eq "BB" and type eq "SU" and dim eq 3 then
        return ClearFirstRowSUBBDim3( G, g : FirstCall := FirstCall );
    elif Method eq "BB" and type in { "Sp", "SU" } then
        return ClearFirstRowSpSUBB( G, g : FirstCall := FirstCall );
    end if;
    
end function;
    
WriteTransvectionAsSLP := function( G, g : Method := "BB", 
				    GetWE1Entry := false )
    
    type := BBType( G );
    
    if Method eq "CharP" then
        return WriteTransvectionAsSLPCharP( G, g );
    elif Method eq "BB" and type eq "SL" then
        return WriteTransvectionAsSLPBBSL( G, g );
    elif Method eq "BB" and type in { "Sp", "SU" } then
        return WriteTransvectionAsSLPBBSpSU( G, g : 
		       GetWE1Entry := GetWE1Entry );
    end if;
    
end function;
      
WriteRootElementAsSLP := function( G, g, n : Method := "BB" )
    
    type := BBType( G );
    
    if Method eq "CharP" then
        return WriteRootElementAsSLPCharP( G, g, n );
    elif Method eq "BB" and type eq "SL" then
        return WriteRootElementAsSLPBBSL( G, g, n );
    elif Method eq "BB" and type in { "Sp", "SU" } then
        return WriteRootElementAsSLPBBSpSU( G, g, n );
    end if;
    
end function;
