freeze;

import "../../recformat.m": SporadicRF;
import "../../List.m": ListMaximals;
import "../../BlackBoxes/Autm/HS.m":StandardGeneratorsHSAutm;

/* generators for maximal subgroups of HS.2 */

GeneratorsHSAutmMax1 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w6:=w4^10;
w1:=w3^-1*w6*w3;
w6:=w4^4;
w7:=w5^4;
w2:=w7^-1*w6*w7;

   return [w1,w2];

end function;

GeneratorsHSAutmMax2 := function (a,b)

   w1 := a; w2 := b;

w3:=w2*w2;
w4:=w1*w3;
w5:=w1*w2;
w6:=w4*w3;
w3:=w4*w4;
w4:=w5*w5;
w5:=w6*w3;
w3:=w5*w4;
w4:=w2^-1;
w5:=w3*w2;
w2:=w4*w5;

   return [w1,w2];

end function;

GeneratorsHSAutmMax3 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w2:=w3*w3;
w3:=w4*w2;
w5:=w3*w4;
w2:=w5*w3;

   return [w1,w2];

end function;

GeneratorsHSAutmMax4 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w3;
w3:=w5*w4;
w6:=w4*w5;
w4:=w3*w2;
w2:=w6^-1;
w3:=w2*w4;
w2:=w3*w6;

   return [w1,w2];

end function;

GeneratorsHSAutmMax5 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w4*w3;
w6:=w2*w2;
w7:=w4*w6;
w4:=w5*w7;
w6:=w2*w5;
w5:=w6*w3;
w2:=w5^-1;
w3:=w2*w4;
w2:=w3*w5;

   return [w1,w2];

end function;

GeneratorsHSAutmMax6 := function (a,b)

   w1 := a; w2 := b;

w3:=w2*w2;
w4:=w1*w3;
w5:=w1*w2;
w6:=w4*w3;
w3:=w5*w5;
w5:=w4*w4;
w7:=w5*w3;
w3:=w7*w4;
w4:=w3*w2;
w2:=w6^-1;
w3:=w2*w4;
w2:=w3*w6;

   return [w1,w2];

end function;

GeneratorsHSAutmMax7 := function (a,b)

   w1 := a; w2 := b;

w3:=w2*w2;
w4:=w1*w2;
w5:=w3*w4;
w6:=w5*w1;
w7:=w6*w6;
w6:=w1*w5;
w5:=w6*w4;
w4:=w5*w1;
w5:=w4*w3;
w3:=w7*w2;
w4:=w5*w2;
w2:=w3^-1;
w5:=w2*w4;
w2:=w5*w3;

   return [w1,w2];

end function;

// BBOX converted automatically from
// http://brauer.maths.qmul.ac.uk/Atlas/spor/HS/words/HSd2G1-max8W1

GeneratorsHSAutmMax8 := function (a,b)

  w1 := a; w2 := b;
  w4 := w1 * w2;
  w5 := w4 * w2;
  w6 := w5 * w4;
  w7 := w6 * w5;
  w8 := w7^3;
  w9 := w4 * w1;
  w10 := w5 * w1;
  w1 := w5^10;
  w3 := w5 * w2;
  w7 := w5 * w5;
  w5 := w2^3;
  w11 := w3 * w3;
  w12 := w2 * w11;
  w11 := w12 * w9;
  w2 := w11^-1;
  w9 := w2 * w8;
  w2 := w9 * w11;
  w8 := w5 * w7;
  w5 := w8 * w10;
  w7 := w6 * w4;
  w4 := w7 * w3;
  w3 := w4 * w4;
  w4 := w5^-1;
  w6 := w4 * w3;
  w3 := w6 * w5;
  return [w1, w2, w3];
end function;

GeneratorsHSAutmMax9 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w1:=w4^5;
w5:=w3^4;
w6:=w4*w2;
w7:=w5*w4;
w4:=w2*w6;
w5:=w6*w3;
w3:=w5*w5;
w5:=w4*w3;
w2:=w5^-1;
w3:=w2*w7;
w2:=w3*w5;

   return [w1,w2];

end function;

GeneratorsHSAutmMax10 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w3;
w5:=w3*w2;
w6:=w2*w5;
w7:=w2^3;
w1:=w4*w7;
w7:=w5*w1;
w1:=w7^5;
w7:=w4*w4;
w4:=w7*w5;
w5:=w4^5;
w4:=w6*w2;
w2:=w6*w3;
w3:=w4*w2;
w2:=w3^-1;
w4:=w2*w5;
w2:=w4*w3;

   return [w1,w2];

end function;


/* list of subgroups of HS:2 */

DataHSAutm := function ()

   F<a, b> := SLPGroup (2);
   
   L := [
   rec <SporadicRF | name := "HS:2", generators := [a, b], order := 88704000>,
   
   rec <SporadicRF | name := "HS", parent := "HS:2", generators := 
   GeneratorsHSAutmMax1(a,b), order := 44352000, index := 2>,
   
   rec <SporadicRF | name := "M22:2", parent := "HS:2", generators := 
   GeneratorsHSAutmMax2(a,b), order := 887040, index := 100>,
   
   rec <SporadicRF | name := "PSL(3,4):2^2", parent := "HS:2", generators := 
   GeneratorsHSAutmMax3(a,b), order := 80640, index := 1100>,
   
   rec <SporadicRF | name := "S8x2", parent := "HS:2", generators := 
   GeneratorsHSAutmMax4(a,b), order := 80640, index := 1100>,
   
   rec <SporadicRF | name := "2^5.S6", parent := "HS:2", generators := 
   GeneratorsHSAutmMax5(a,b), order := 23040, index := 3850>,
   
   rec <SporadicRF | name := "4^3:(2xPSL(3,2))", parent := "HS:2", generators := 
   GeneratorsHSAutmMax6(a,b), order := 21504, index := 4125>,
   
   rec <SporadicRF | name := "2^{1+6}.S5", parent := "HS:2", generators := 
   GeneratorsHSAutmMax7(a,b), order := 15360, index := 5775>,
   
   rec <SporadicRF | name := "(2xA6.2^2).2", parent := "HS:2", generators := 
   GeneratorsHSAutmMax8(a,b), order := 5760, index := 15400>,
   
   rec <SporadicRF | name := "5^{1+2}:[2^5]", parent := "HS:2", generators := 
   GeneratorsHSAutmMax9(a,b), order := 4000, index := 22176>,
   
   rec <SporadicRF | name := "5:(4xS5)", parent := "HS:2", generators := 
   GeneratorsHSAutmMax10(a,b), order := 2400, index := 36960>

   ];
   
   return L;
   
end function;

/* code to find standard generators of HS:2 and 
   produce listing of maximal subgroups */

MaximalsHSAutm := function (G)

   x, y := StandardGeneratorsHSAutm(G);
   if Type(x) eq BoolElt then "Unable to find Standard Generators"; return false; end if;

   G := sub<G|x[1],x[2]>;
   return ListMaximals(G, "HS:2", DataHSAutm());

end function;

