freeze;

import "../../recformat.m": SporadicRF;
import "../../List.m": ListMaximals;
import "../../BlackBoxes/Autm/J2.m":StandardGeneratorsJ2Autm;

/* generators for maximal subgroups of J2:2 */

GeneratorsJ2AutmMax1 := function (a,b)
   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w6:=w3*w5;
w1:=w6^18;
w2:=w6^16;
w5:=w4^3;
w6:=w5^-1;
w7:=w6*w2;
w2:=w7*w5;

   return [w1,w2];
end function;

GeneratorsJ2AutmMax2 := function (a,b)
   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3^3;
w5:=w4*w4;
w6:=w2*w2;
w7:=w4*w2;
w4:=w3*w6;
w3:=w4*w5;
w4:=w7^-1;
w5:=w4*w3;
w2:=w5*w7;

   return [w1,w2];
end function;

GeneratorsJ2AutmMax3 := function (a,b)
   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w3;
w5:=w4^3;
w6:=w2*w2;
w7:=w3*w6;
w3:=w7*w5;
w5:=w6*w4;
w4:=w5^-1;
w6:=w4*w3;
w2:=w6*w5;

   return [w1,w2];
end function;

GeneratorsJ2AutmMax4 := function (a,b)
   w1 := a; w2 := b;

w3:=w2*w2;
w4:=w3*w1;
w2:=w4^3;

   return [w1,w2];
end function;

GeneratorsJ2AutmMax5 := function (a,b)
   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w6:=w4*w5;
w7:=w6*w6;
w2:=w7*w5;

   return [w1,w2];
end function;

GeneratorsJ2AutmMax6 := function (a,b)
   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3^3;
w3:=w2*w2;
w2:=w3*w4;

   return [w1,w2];
end function;

GeneratorsJ2AutmMax7 := function (a,b)
   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3^4;
w6:=w4*w4;
w4:=w3*w6;
w1:=w4*w5;

   return [w1,w2];
end function;

GeneratorsJ2AutmMax8 := function (a,b)
   w1 := a; w2 := b;

w3:=w2^4;
w4:=w1*w2;
w5:=w4^4;
w6:=w4*w2;
w7:=w3*w4;
w4:=w7*w1;
w2:=w6*w5;
w5:=w4*w3;
w3:=w5^-1;
w4:=w3*w2;
w2:=w4*w5;

   return [w1,w2];
end function;

GeneratorsJ2AutmMax9 := function (a,b)
   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w1:=w4^12;
w2:=w4*w3;
w4:=w2*w3;
w5:=w4^3;
w4:=w3*w2;
w3:=w4^-1;
w6:=w3*w5;
w2:=w6*w4;

   return [w1,w2];
end function;


GeneratorsJ2AutmMax10 := function (a,b)
   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w3;
w6:=w4*w5;
w7:=w6^3;
w3:=w2^-1;
w4:=w2*w1;
w2:=w4*w3;
w3:=w2*w1;
w4:=w3^-1;
w5:=w4*w7;
w2:=w5*w3;

   return [w1,w2];
end function;


/* list of subgroups of J2:2 */

DataJ2Autm := function ()

   F<a, b> := SLPGroup (2);
   
   L := [
   rec <SporadicRF | name := "J2:2", generators := [a, b], order := 1209600>,
   
   rec <SporadicRF | name := "J2", parent := "J2:2", generators := 
   GeneratorsJ2AutmMax1(a,b), order := 604800, index := 2>,
   
   rec <SporadicRF | name := "PSU(3,3):2", parent := "J2:2", generators := 
   GeneratorsJ2AutmMax2(a,b), order := 12096, index := 100>,
   
   rec <SporadicRF | name := "3.A6.2^2", parent := "J2:2", generators := 
   GeneratorsJ2AutmMax3(a,b), order := 4320, index := 280>,
   
   rec <SporadicRF | name := "2^{1+4}.S5", parent := "J2:2", generators := 
   GeneratorsJ2AutmMax4(a,b), order := 3840, index := 315>,
   
   rec <SporadicRF | name := "2^{2+4}:(3xS3).2", parent := "J2:2", generators := 
   GeneratorsJ2AutmMax5(a,b), order :=2304, index := 525>,
   
   rec <SporadicRF | name := "(A4xA5):2", parent := "J2:2", generators := 
   GeneratorsJ2AutmMax6(a,b), order := 1440, index := 840>,
   
   rec <SporadicRF | name := "(A5xD10).2", parent := "J2:2", generators := 
   GeneratorsJ2AutmMax7(a,b), order := 1200, index := 1008>,
   
   rec <SporadicRF | name := "PSL(3,2):2x2", parent := "J2:2", generators := 
   GeneratorsJ2AutmMax8(a,b), order := 672, index := 1800>,
   
   rec <SporadicRF | name := "5^2:(4xS3)", parent := "J2:2", generators := 
   GeneratorsJ2AutmMax9(a,b), order := 600, index := 2016>,
   
   rec <SporadicRF | name := "S5", parent := "J2:2", generators := 
   GeneratorsJ2AutmMax10(a,b), order := 120, index := 10080>

   ];
   
   return L;
   
end function;

/* code to find standard generators of J2:2 and 
   produce listing of maximal subgroups */

MaximalsJ2Autm := function (G)

   x, y := StandardGeneratorsJ2Autm(G);
   if Type(x) eq BoolElt then "Unable to find Standard Generators"; return false; end if;

   G := sub<G|x[1],x[2]>;
   return ListMaximals(G, "J2:2", DataJ2Autm());

end function;

