freeze;

import "../../recformat.m": SporadicRF;
import "../../List.m": ListMaximals;
import "../../BlackBoxes/Autm/M12.m":StandardGeneratorsM12Autm;

/* generators for maximal subgroups of M12:2 */

GeneratorsM12AutmMax1 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w6:=w3*w5;
w7:=w6*w3;
w6:=w7*w7;
w1:=w7*w6;
w5:=w3*w3;
w2:=w5*w5;
w3:=w4*w4;
w5:=w4*w3;
w4:=w5^-1;
w3:=w4*w2;
w2:=w3*w5;

   return [w1,w2];

end function;

GeneratorsM12AutmMax2 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w2*w3;
w5:=w2*w4;
w2:=w3*w3;
w3:=w2*w4;
w2:=w5*w3;

   return [w1,w2];

end function;

GeneratorsM12AutmMax3 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w3;
w5:=w4*w4;
w3:=w2*w4;
w2:=w3^-1;
w4:=w2*w5;
w2:=w4*w3;

   return [w1,w2];

end function;

GeneratorsM12AutmMax4 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w2*w3;
w5:=w3*w3;
w2:=w4*w4;
w3:=w5*w5;
w6:=w2*w3;
w3:=w5*w6;
w2:=w3*w4;

   return [w1,w2];

end function;

GeneratorsM12AutmMax5 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w2:=w3^3;
w3:=w5*w2;
w2:=w5*w4;
w5:=w2*w4;
w2:=w5*w3;

   return [w1,w2];

end function;

GeneratorsM12AutmMax6 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w3;
w5:=w4*w4;
w6:=w2*w3;
w7:=w3*w6;
w8:=w2*w4;
w9:=w8*w6;
w3:=w5*w7;
w4:=w3*w7;
w1:=w4*w2;
w3:=w5*w9;
w4:=w3*w2;
w3:=w4^3;
w2:=w9^-1;
w4:=w2*w3;
w2:=w4*w9;

   return [w1,w2];

end function;

GeneratorsM12AutmMax7 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w4*w3;
w2:=w5*w4;
w4:=w5*w3;
w5:=w2*w4;
w2:=w5*w3;

   return [w1,w2];

end function;

GeneratorsM12AutmMax8 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w2:=w3*w5;
w4:=w3*w2;
w2:=w4*w4;
w4:=w2*w3;
w2:=w5*w4;

   return [w1,w2];

end function;

GeneratorsM12AutmMax9 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3^3;
w3:=w2^-1;
w5:=w4*w2;
w2:=w3*w5;

   return [w1,w2];

end function;


/* list of subgroups of M12:2 */

DataM12Autm := function ()

   F<a, b> := SLPGroup (2);
   
   L := [
   rec <SporadicRF | name := "M12:2", generators := [a, b], order := 190080>,
   
   rec <SporadicRF | name := "M12", parent := "M12:2", generators := 
   GeneratorsM12AutmMax1(a,b), order := 95040, index := 2>,

   rec <SporadicRF | name := "PSL(2,11):2", parent := "M12:2", generators := GeneratorsM12AutmMax2(a,b), order := 1320, index := 144>,

   rec <SporadicRF | name := "PSL(2,11):2", parent := "M12:2", generators := GeneratorsM12AutmMax3(a,b), order := 1320, index := 144>,

   rec <SporadicRF | name := "(2x2xA5).2", parent := "M12:2", generators := GeneratorsM12AutmMax4(a,b), order := 480, index := 396>,

   rec <SporadicRF | name := "2^{1+4}:S3.2", parent := "M12:2", generators := GeneratorsM12AutmMax5(a,b), order := 384, index := 495>,

   rec <SporadicRF | name := "4^2:D12.2", parent := "M12:2", generators := GeneratorsM12AutmMax6(a,b), order := 384, index := 495>,

   rec <SporadicRF | name := "3^{1+2}:D8", parent := "M12:2", generators := GeneratorsM12AutmMax7(a,b), order := 216, index := 880>,

   rec <SporadicRF | name := "S4xS3", parent := "M12:2", generators := GeneratorsM12AutmMax8(a,b), order := 144, index := 1320>,

   rec <SporadicRF | name := "S5", parent := "M12:2", generators := GeneratorsM12AutmMax9(a,b), order := 120, index := 1584>
   
   ];
   
   return L;
   
end function;

/* code to find standard generators of M12:2 and produce listing of maximal subgroups */

MaximalsM12Autm := function (G)

   x, y := StandardGeneratorsM12Autm(G);
   if Type(x) eq BoolElt then "Unable to find Standard Generators"; return false; end if;

   G := sub<G|x[1],x[2]>;
   return ListMaximals(G, "M12:2", DataM12Autm());

end function;
