freeze;

import "../../recformat.m": SporadicRF;
import "../../List.m": ListMaximals;
import "../../BlackBoxes/Autm/McL.m":StandardGeneratorsMcLAutm;

/* generators for maximal subgroups of McL:2 */

GeneratorsMcLAutmMax1 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w6:=w3*w5;
w7:=w6*w3;
w8:=w6*w7;
w1:=w8^12;
w6:=w3^-1;
w7:=w6*w1;
w1:=w7*w3;
w6:=w5*w5;
w2:=w5*w6;
w5:=w4*w4;
w6:=w4*w5;
w7:=w6^-1;
w5:=w7*w2;
w2:=w5*w6;

   return [w1,w2];

end function;

GeneratorsMcLAutmMax2 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w2:=w4*w3;
w4:=w2*w3;
w3:=w5*w5;
w2:=w3*w4;

   return [w1,w2];

end function;

GeneratorsMcLAutmMax3 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w2*w3;
w5:=w3*w4;
w4:=w5*w5;
w6:=w4*w3;
w2:=w6*w5;

   return [w1,w2];

end function;

GeneratorsMcLAutmMax4 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w2:=w3*w3;
w3:=w4*w4;
w4:=w5*w5;
w5:=w3*w2;
w2:=w5*w4;

   return [w1,w2];

end function;

GeneratorsMcLAutmMax5 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w4*w3;
w2:=w5^3;
w6:=w3*w3;
w3:=w2*w6;
w2:=w4*w4;
w4:=w5*w2;
w2:=w3*w4;

   return [w1,w2];

end function;

GeneratorsMcLAutmMax6 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3^9;
w5:=w2*w4;
w4:=w3*w3;
w2:=w4*w5;

   return [w1,w2];

end function;

GeneratorsMcLAutmMax7 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3^5;
w5:=w3*w2;
w6:=w3^3;
w7:=w5^3;
w8:=w6*w7;
w6:=w3*w5;
w7:=w6*w3;
w9:=w2*w6;
w6:=w4*w9;
w9:=w6^5;
w6:=w5^-1;
w2:=w6*w9;
w1:=w2*w5;
w6:=w7*w7;
w2:=w6*w4;
w4:=w5*w3;
w3:=w4*w4;
w4:=w2*w3;
w2:=w4^-1;
w3:=w2*w8;
w2:=w3*w4;

   return [w1,w2];

end function;

GeneratorsMcLAutmMax8 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w3;
w5:=w3*w2;
w6:=w4*w2;
w2:=w6*w3;
w3:=w2*w2;
w2:=w4*w4;
w7:=w5*w5;
w5:=w3*w2;
w2:=w4*w7;
w3:=w2*w6;
w4:=w5^-1;
w6:=w4*w3;
w2:=w6*w5;

   return [w1,w2];

end function;

GeneratorsMcLAutmMax9 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3^6;
w6:=w4*w4;
w7:=w3*w1;
w1:=w5*w6;
w5:=w4*w3;
w8:=w3*w3;
w9:=w8*w4;
w8:=w9*w9;
w9:=w3*w8;
w8:=w6*w5;
w6:=w8*w8;
w3:=w2*w6;
w5:=w3*w4;
w3:=w5*w7;
w2:=w3^-1;
w4:=w2*w9;
w2:=w4*w3;

   return [w1,w2];

end function;

GeneratorsMcLAutmMax10 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w3;
w6:=w5*w4;
w7:=w5*w3;
w5:=w2*w2;
w2:=w5*w7;
w5:=w2^-1;
w7:=w6*w2;
w2:=w5*w7;
w5:=w6*w4;
w1:=w5*w3;
w3:=w1*w4;
w1:=w3*w3;

   return [w1,w2];

end function;

/* list of subgroups of McL:2 */

DataMcLAutm := function ()

   F<a, b> := SLPGroup (2);
   
   L := [
   rec <SporadicRF | name := "McL:2", generators := [a, b], order := 1796256000>,
   
   rec <SporadicRF | name := "McL", parent := "McL:2", generators := 
   GeneratorsMcLAutmMax1(a,b), order := 898128000, index := 2>,
   
   rec <SporadicRF | name := "PSU(4,3):2", parent := "McL:2", generators := 
   GeneratorsMcLAutmMax2(a,b), order := 6531840, index := 275>,
   
   rec <SporadicRF | name := "PSU(3,5):2", parent := "McL:2", generators := 
   GeneratorsMcLAutmMax3(a,b), order := 252000, index := 7128>,
   
   rec <SporadicRF | name := "3^{1+4}:4.S5", parent := "McL:2", generators := 
   GeneratorsMcLAutmMax4(a,b), order := 116640, index := 15400>,
   
   rec <SporadicRF | name := "3^4:(M10x2)", parent := "McL:2", generators := 
   GeneratorsMcLAutmMax5(a,b), order := 116640, index := 15400>,
   
   rec <SporadicRF | name := "PSL(3,4):2:2", parent := "McL:2", generators := 
   GeneratorsMcLAutmMax6(a,b), order := 80640, index := 22275>,
   
   rec <SporadicRF | name := "2.S8", parent := "McL:2", generators := 
   GeneratorsMcLAutmMax7(a,b), order := 80640, index := 22275>,
   
   rec <SporadicRF | name := "M11x2", parent := "McL:2", generators := 
   GeneratorsMcLAutmMax8(a,b), order := 15840, index := 113400>,
   
   rec <SporadicRF | name := "5^{1+2}:3:8.2", parent := "McL:2", generators := 
   GeneratorsMcLAutmMax9(a,b), order := 6000, index := 299376>,
   
   rec <SporadicRF | name := "2^{2+4}:(S3xS3)", parent := "McL:2", generators := 
   GeneratorsMcLAutmMax10(a,b), order := 2304, index := 779625>

   ];
   
   return L;
   
end function;

/* code to find standard generators of McL:2 and produce listing of maximal subgroups */

MaximalsMcLAutm := function (G)

   x, y := StandardGeneratorsMcLAutm(G);
   if Type(x) eq BoolElt then "Unable to find Standard Generators"; return false; end if;

   G := sub<G|x[1],x[2]>;
   return ListMaximals(G, "McL:2", DataMcLAutm());

end function;

